//+------------------------------------------------------------------+
//|                                                         asad.mq5 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"


extern double lot_size = 0.03;     // lot size that use for trade
extern int magic_num = 786;
extern int        pips=10; // Distance between levels
extern int        FixedSpread=3;// TP pips multiply n times
int my_slippage = 2;


////
//2 Bars indicator
double prevtime;
double pt;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

/*
Self reminder comment
https://book.mql4.com/appendix/errors
https://book.mql4.com/appendix/marketinfo

===>Open order
int OrderSend (string symbol, int cmd, double volume, double price, int slippage, double stoploss,
double takeprofit, string comment=NULL, int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)

Opening Buy
OrderSend(Symbol(),OP_BUY,0.01,Ask,2,Bid-20*Point,Ask+30*Point);
 OrderSend("EURUSD","Buy/sell/buy limit",VOLUME,Ask,2,SL,TP);
  Alert (GetLastError());     
*/

double  spread=FixedSpread;
extern string ex1 = "Select which bar pattern apply";
extern string ex2 = "REVERSAL BAR : 80/100 good but fail in some currencies";
extern bool check_reversal_bar = true;
extern string ex3 = "EXHAUSTION BAR: 50/100";
extern bool check_exhaustion_bar = true;
extern string ex4 = "Pin Bar: 50/100";
extern bool check_pin_bar = true;
extern string ex5 = "2-BAR REVERSAL: 70/100";
extern bool check_two_bars_revarsal = true;
extern string ex6 = "3-BAR REVERSAL: 30/100";
extern bool check_three_bars_revarsal = true;
extern string ex7 = "3-BAR PULLBACK: 30/100"; 
extern bool check_inside_bar = true;
extern string ex8 = "INSIDE BAR: 10/100"; 
extern bool check_three_bar_pullback = true;
extern string ex9 = "OUTSIDE BAR: 10/100"; 
extern bool check_outside_bar = true;

int start_trading = 1;
int OnInit()
  {
  

  if(pips<MarketInfo(Symbol(),MODE_STOPLEVEL)+spread) pips=1+MarketInfo(Symbol(),MODE_STOPLEVEL)+spread;
  if(lot_size<MarketInfo(Symbol(),MODE_MINLOT)) lot_size=MarketInfo(Symbol(),MODE_MINLOT);
  
   if(Digits==3 || Digits==5){
      pt=Point*10;
   }else{
      pt=Point;
   }
   
   buttons();
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
//When expert remove;
 Print("Bot deniet",Symbol()," : period: "+Period());

}
  
  
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  // indicators candles https://www.tradingsetupsreview.com/10-price-action-bar-patterns-must-know/#reversalbar
  
  
// log_pinbar();

if(check_pin_bar)
   pin_bar();   // 50/100
   
if(check_outside_bar)
   outside_bar(); // 10/100 Fraud market

if(check_inside_bar)
   inside_bar(); // 10/100 Fraud market

if(check_three_bar_pullback)
   three_bar_pullback(); // 30/100

if(check_three_bars_revarsal)
   three_bars_revarsal(); // 70/100 low order chance but mostly in profit.
   
if(check_two_bars_revarsal)   
   two_bars_revarsal(); // 50/100

if(check_exhaustion_bar)
  exhaustion_bar(); // 50/100

if(check_reversal_bar)
   bars_revarsal();  //80/100

}
//+------------------------------------------------------------------+


bool log_pinbar()
{

// custom logic, buy when single candle move 250 pips, then trade in opposite direction
   
   if(
      Open[0] > Close[0] && // bear
      Open[0] > Close[0]+25*pt && // tail length
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",8);
   }
   
   //assume 2nd is bull
   if(
      Open[0] < Close[0] && // bear
      Open[0] < Close[0]-25*pt && // tail length
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",8);
   }
   
 }
 
bool pin_bar()
{

/*An inside bar must stay completely within the range of the bar immediately before it. In other words, the second bar must have a lower high and a higher low.
*/
   
   //assume 2nd is bull
   if(
      Open[2] > Close[2] && // bear bar
      Open[1] < Close[1] && // bull
      High[1] < High[2] && // 1st high is below then 2nd high
      Low[1]  < Low[2] && // 1st high is lower 2nd low
      Open[1] > Low[1]+9*pt && // tail length
      Low[2] > Low[1]+8*pt && // tail length
      Low[1] < Low[3] &&
      Open[1] > Close[1]-3*pt && //stop extra pin body
  //    Close[0] > High[2] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",5);
   }

   if(
      Open[2] > Close[2] && // bear bar
      Open[1] < Close[1] && // bull
      High[1] < High[2] && // 1st high is below then 2nd high
      Low[1]  < Low[2] && // 1st high is lower 2nd low
      Open[1] > Low[1]+7*pt && // tail length
      Low[2] > Low[1]+6*pt && // tail length
      Open[1] > Close[1]+3*pt && //stop extra pin body
      Close[0] > High[2] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
     // SendAlert("Bearish",5);
   }   
 }
 
bool outside_bar()
{

/*An inside bar must stay completely within the range of the bar immediately before it. In other words, the second bar must have a lower high and a higher low.
*/
   
   //assume 2nd is bull
   if(
      Open[2] < Close[2]-1*pt && // bull bar
      Open[1] > Close[1] && // bear
      High[1] > High[2] && // 1st high is above then 2nd high
      Low[1] < Low[2] && // 1st high is lower 2nd low
      Open[2] > Close[1] &&
      Close[2] < Open[1] &&     
      Close[0] < Low[1] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",6);
   }
   
   
   if(
      Open[2] > Close[2]+1*pt && // bear bar
      Open[1] > Close[1] && // bull
      High[1] > High[2] && // 1st high is above then 2nd high
      Low[1] < Low[2] && // 1st high is lower 2nd low
      Open[2] < Close[1] &&
      Close[2] > Open[1] &&     
      Close[0] > High[1] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",6);
   }

 }

bool inside_bar()
{

/*An inside bar must stay completely within the range of the bar immediately before it. In other words, the second bar must have a lower high and a higher low.
*/

   
   //assume 2nd is bull
   if(
      Open[2] < Close[2]-2*pt && // bull bar
      Open[1] > Close[1]+1*pt && // bear
      High[1] < High[2] && // 1st high is lower then 2nd high
      Low[1] > Low[2] && // 1st high is above 2nd low
      Open[2] < Close[1] &&
      Close[2] > Open[1] &&     
      Close[0] > High[2] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",5);
   }
   
   
   if(
      Open[1] < Close[1]-1*pt && // bull bar
      Open[2] > Close[2]+2*pt && // bear
      High[1] < High[2] && // 1st high is lower then 2nd high
      Low[1] > Low[2] && // 1st high is above 2nd low
      Open[2] > Close[1] &&
      Close[2] < Open[1] &&
      Close[0] < Low[2] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",5);
   }

 }
 
bool three_bar_pullback()
{

/*Within a bull trend, wait for three consecutive bearish bars. Then, buy above the next bullish bar.
Within a bear trend, wait for three consecutive bullish bars. Then, sell below the next bearish bar.
*/

   
   if(
      Close[4] < Open[4]-3*pt && // Check 3 bear bars -2*pt for some body
      Close[3] < Open[3]-3*pt && // bear bar
      Close[2] < Open[2]-3*pt && // bear bar
      Close[1] > Open[1]+3*pt && // Bull bar
      Open[1]  > Close[2]+0.1*pt && // open is greater then 2nd close
      Close[0] > High[1]+0.1*pt && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",4);
   }
   
   
   if(
      Close[4] > Open[4]+3*pt && // Check 3 bear bars -2*pt for some body
      Close[3] > Open[3]+3*pt && // bear bar
      Close[2] > Open[2]+3*pt && // bear bar
      Close[1] < Open[1]-3*pt && // Bull bar
      Open[1]  < Close[2]-0.1*pt && // open is greater then 2nd close
      Close[0] < Low[1]-0.1*pt && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",4);
   }

 }
 
bool three_bars_revarsal()
{

/*A bullish bar
A bar has a higher high and higher low
A bearish bar with a lower high and closes below the low of the second bar
*/

   if(
      Close[3] < Open[3] && // 3rd bear bar
      High[2]  < Close[1] && // 2nd bar high is below then 1st close
      High[2] < Open[3] && // 2nd high is below then 3rd open
      Low[2]  < Low[1] && Low[2] < Low[3] && // 2nd low is lower then 1st and 3rd
      Low[2]+3*pt < Low[1] && // big lower then 1st low
      Low[1] < Low[3] && // 1st low is below 3rd low
      High[1] > High[3] && //1st high is above then 3rd high
      Close[1] > Open[1]+3*pt && //1st bull bar add pips for some body
      Close[2] < Open[2]-2*pt && //2nd bear bar add pips for some body
      Close[3] < Open[3]-3*pt && //3rd bear bar add pips for some body
     // Open[1]  > Close[2]+0.1*pt && // open is greater then 2nd close
      Close[0] > High[1] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",4);
   }
   
   if(
      Close[3] > Open[3] && // 3rd bull bar
      Low[2]  > Close[1] && // 2nd bar high is above then 1st close
      Low[2] > Open[3] && // 2nd low is above then 3rd open
      High[2]  > High[1] && High[2] > High[3] && // 2nd high is higher then 1st and 3rd
      High[2]-3*pt > High[1] && // big higher then 1st low
      High[1] > High[3] && // 1st High is above 3rd High
      Low[1] < Low[3] && //1st Low is below then 3rd Low
      Close[1] < Open[1]-3*pt && //1st bear bar add pips for some body
      Close[2] > Open[2]+2*pt && //2nd bull bar add pips for some body
      Close[3] > Open[3]+3*pt && //3rd bull bar add pips for some body
     // Open[1]  > Close[2]+0.1*pt && // open is greater then 2nd close
      Close[0] < Low[1] && // current close greater then third last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",4);
   }
}


bool two_bars_revarsal()
{
   if(
      Close[2] < Open[2] && // 2nd bear bar
      Close[1] > Open[1]+3*pt && //1st bull bar add pips for some body
      Low[1]-1*pt > Low[2] && //lower is above then 2nd lower
      High[1]+1*pt < High[2] && //first high is lower then 2nd high
      Open[1]  > Close[2]+0.1*pt && // open is greater then 2nd close
      Close[0] > High[2] && // current close greater then second last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",3);
   }
   
   
   //Bearish
   if(
      Close[2] > Open[2] && // 2nd bull bar
      Close[1] < Open[1]-3*pt && //1st bear bar add pips for some body
      Low[1]-1*pt > Low[2] && //lower is above then 2nd lower
      High[1]+1*pt < High[2] && //first high is lower then 2nd high
      Open[1]  < Close[2]-0.1*pt && // open is lower then 2nd close
      Close[0] < Low[2] && // current close greater then second last high to open order
     (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",3);
   }

 }

//need improvements, some time wrong...
// 50/50 chance if remove comment on 1 condition
bool exhaustion_bar(){
   //bullish below last bar
   if(
      Close[1] > Open[1] && // 1st bull bar
      Close[1] < Low[2]  && // close below 2nd bar
      Open[1] < Low[2]  &&  // open below 2nd bar 
    //  Close[0] < Low[1]-2*pt && //50/50 current close lower then last low to open order
      (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",2);
   }

   //bear above last bar
   if(
      Close[1] < Open[1] && // 1st bull bar
      Close[1] < Low[2]  && // close below 2nd bar
      Open[1] < Low[2]  &&  // close below 2nd bar
   //   Close[0] < Low[1]-2*pt && // current close lower then last low to open order
      (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",2);
   }
   
    //bear above last bar
   if(
      Close[1] < Open[1] && // 1st bear bar
      Open[1] > High[2] && // open above 2nd high
      Close[1] > High[2]  && // close above 2nd high
   //   Close[0] > High[1]+2*pt &&// current close lower then last low to open order
      (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",2);
   }
   
   //bull above last bar
   if(
      Close[1] > Open[1] && // 1st bear bar
      Open[1] > High[2] && // open above 2nd high
      Close[1] > High[2]  && // close above 2nd high
    //  Close[0] > High[1]+2*pt && // current close lower then last low to open order
      (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",2);
   }
   

}

int bars_revarsal()
{
/* 3 Digits
121.776 +0.1 = 121.777
121.776 +2 = 121.796

5 Digits
1.07776 + 0.1 = 1.07777
1.07776 + 2 = 1.07796

Close[2], = " add 0.1: ",Close[2]+0.1*pt
 Print("vallll normal1: ",Close[2]," add 0.1: ",Close[2]+0.1*pt);
 Print("vallll normal2: ",Close[2]," add 0.3: ",Close[2]+0.3*pt);
 Print("vallll normal3: ",Close[2]," add 2: ",Close[2]+2*pt);
*/
   
   
   
   if(
      Close[2] < Open[2] && // 2nd bear bar
      Close[1] > Open[1]+2*pt && //1st bull bar add pips for some body
      Open[1]  > Close[2]+0.1*pt && // open is greater then 2nd close
      Low[1]+1*pt < Low[2] && //lower is lower then 2nd lower
      High[1] < Open[2] && //first high is lower then 2nd open
      Close[1] < Open[2] && // close lower then 2nd open
      Close[0] > High[1]+2*pt // current close greater then last high to open order
      && (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bullish",1);
   }
   
   
   //Bearish
   if(Close[2] > Open[2] && // 2nd bull bar
      Close[1] < Open[1]-2*pt && //1st bear bar add pips for some body
      Open[1] < Close[2]-0.1*pt &&  // open is lower then 2nd close
      Low[1] > Open[2]+1*pt && //lower is greater then 2nd open
      High[1] > High[2]+1*pt && //first high is greater then 2nd high
      Close[1] > Open[2] && // close greater then 2nd open
      Close[0] < Low[1]-2*pt // current close lower then last lower to open order
      && (prevtime!=Time[0])){
      prevtime=Time[0];
      SendAlert("Bearish",1);
   }

   
//   Print("CrossUp[0]:",CrossUp[0]);
   return(0);
 }


void SendAlert(string dir,int type = 0)
{
   if(dir == "Bullish"){
      buy_order(type);
   }
   
   if(dir == "Bearish"){
      sell_order(type);
   }

}

void buy_order(int type = 0){
 //if(is_order_open() == false){
  
  int sl,tp;
  double SL,TP,price,price2;
  price = Low[1];
  price2 = Low[2];
  //get last lowset price
  if(price > price2){
      price = price2;
  }
  if(type == 0 || type == 1){
     //add more pips in lowest price 
     sl = pips;
     tp = 150; // fixed TP pips
     
  }else if(type == 2){
     // price = Low[1];
      sl = pips;
      tp = 120;
  }else if(type == 3){
     // price = Low[1];
      sl = pips;
      tp = 100;
  }else if(type == 4){
     // price = Low[1];
      sl = pips;
      tp = 100;
  }else if(type == 5){
      sl = pips;
      tp = 100;
  }else if(type == 8){
      sl = pips;
      tp = 120;
  }else{
     sl = pips*2;
     tp = pips*2; //fixed TP pips
  }
  

  SL = min_pips_in_price(price,sl);       
  TP = add_pips_in_price(Ask,tp);          // Requested price of TP

  int max_sl = pips*3; // 10*2
  price = MathAbs(NormalizeDouble(Bid-SL,Digits)/Point); // 10-6
  if(price > max_sl || price < pips+10){
      SL = min_pips_in_price(Bid,max_sl);       
  }
  
     
  Print("-------------------------------------- Buy signal");

  string comment = "Buy auto Type: "+type;
  OrderSend(Symbol(),OP_BUY,lot_size,Ask,my_slippage,SL,TP,comment,magic_num);
 // }
}

void sell_order(int type = 0){
   //buy if candle is bull

  int sl,tp;
  double SL,TP,price,price2;
  //get last higest price
  price = High[1];
  price2 = High[2]; 
  if(price < price2){
      price = price2;
  }
   if(type == 0 || type== 1){
     //add more pips in lowest price
     sl = pips;
     tp = 150; // fixed TP pips
  }else if(type == 2){
    //  price = High[1];
      sl = pips*1.5;
      tp = 120;
  }else if(type == 3){
     // price = Low[1];
      sl = pips;
      tp = 120;
  }else if(type == 4){
     // price = Low[1];
      sl = pips;
      tp = 100;
  }else if(type == 5){
      sl = pips;
      tp = 100;
  }else if(type == 8){
      sl = pips;
      tp = 120;
  }else{
     sl = pips*2;
     tp = pips*2; //fixed TP pips
  }
  
  SL = add_pips_in_price(price,sl);       
  TP = min_pips_in_price(Bid,tp);          // Requested price of TP
   
  int max_sl = pips*3; // 10*2
  price = MathAbs(NormalizeDouble(SL-Ask,Digits)/Point); // 10-6
  if(price > max_sl || price < pips+10){
      SL = add_pips_in_price(Ask,max_sl);       
  }
  
  Print("-------------------------------------- Sell signal, sl:",SL," TP:",TP);    
  string comment = "Sell auto Type: "+type; 
  OrderSend(Symbol(),OP_SELL,lot_size,Bid,my_slippage,SL,TP,comment,magic_num);

}

void buttons(){
   //Trading button
   ObjectCreate(0,"CloseButton",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"CloseButton",OBJPROP_XDISTANCE,235);
   ObjectSetInteger(0,"CloseButton",OBJPROP_YDISTANCE,2);
   ObjectSetInteger(0,"CloseButton",OBJPROP_XSIZE,100);
   ObjectSetInteger(0,"CloseButton",OBJPROP_YSIZE,20);
if(start_trading  == 1){
   ObjectSetString(0,"CloseButton",OBJPROP_TEXT,"Stop Trading");
}else{
   ObjectSetString(0,"CloseButton",OBJPROP_TEXT,"Start Trading");
}

   ObjectSetInteger(0,"CloseButton",OBJPROP_COLOR, White);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BGCOLOR, Red);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BORDER_COLOR,Red);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSetInteger(0,"CloseButton",OBJPROP_HIDDEN,false);
   ObjectSetInteger(0,"CloseButton",OBJPROP_STATE,true);
   ObjectSetInteger(0,"CloseButton",OBJPROP_FONTSIZE,10);

}


void OnChartEvent(const int id,  const long &lparam,  const double &dparam,  const string &sparam)
  {
  if(sparam=="CloseButton") // Close button has been pressed
   {
      if(start_trading == 0){
         ObjectSetInteger(0,"CloseButton",OBJPROP_STATE,false);
         ObjectSetString(0,"CloseButton",OBJPROP_TEXT,"Stop Trading");
         start_trading = 1;
      }else{
         ObjectSetInteger(0,"CloseButton",OBJPROP_STATE,true);
         ObjectSetString(0,"CloseButton",OBJPROP_TEXT,"Start Trading");
         start_trading = 0;
      }
   }
  
  
 }



double add_pips_in_price(double price,double pip){
 double newPrice =0;
   if(Digits == 5){
      newPrice = price + (pip/100000);
   }else if(Digits == 4){
      newPrice = price + (pip/10000);
   }else if(Digits == 3){
      newPrice = price + (pip/1000);
   }
   return (newPrice);
}

double min_pips_in_price(double price,double pip){
 double newPrice =0;
   if(Digits == 5){
      newPrice = price - (pip/100000);
   }else if(Digits == 4){
      newPrice = price - (pip/10000);
   }else if(Digits == 3){
      newPrice = price - (pip/1000);
   }
   return (newPrice);
}
